{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 65520,0,655360}
program Checker;
type
  Block = record
	orient: byte;
	c: array[1..2] of byte;
	len: byte;
  end;
  TState = array[1..18] of byte;

var
  Table:Array[1..6,1..6] of byte;
  FIn, FOut, UserOut:text;
  B:Array[1..20] of Block;
  Uout,i,out,n,j,k:integer;
  Found:boolean;

procedure Error(s:string);
begin
  Assign(output,'$answer$.txt');
  Rewrite(output);
  Writeln(s);
  Close(output);
  Halt;
end;

function CanPut(i:integer):boolean;
var j:integer;
	X:Array[1..2] of byte;

begin
  CanPut:=false;
  X[3-B[i].orient]:=B[i].c[3-B[i].orient];
  X[B[i].orient]:=B[i].C[B[i].orient];
  for j:=1 to B[i].len do
	begin
	  if (X[1]>6)or(X[2]>6)or(X[1]<1)or(X[2]<1) then Error('Test not passed');
	  if Table[X[1], X[2]] <> 0
		then exit
		else inc(X[B[i].orient]);
    end;
  CanPut:=true;
end;

procedure Put(i:integer; color:integer);
var j:integer;
    X:Array[1..2] of byte;

begin
  X[3-B[i].orient]:=B[i].c[3-B[i].orient];
  X[B[i].orient]:=B[i].c[B[i].orient];
  for j:=1 to B[i].len do
    begin
	  if (X[1]>6)or(X[2]>6)or(X[1]<1)or(X[2]<1) then Error('Test not passed');
      Table[X[1], X[2]]:=color;
      inc(X[B[i].orient]);
	end;
end;

procedure CreateTable;
var
  i:integer;
begin
  Fillchar(Table, sizeof(Table), 0);
  for i:=1 to n do
    Put(i,1);
end;

procedure InputData;
var
  i:integer;
  ch:char;
begin
  Readln(FIn,n);
  for i:=1 to n do
    begin
	  read(FIn,ch);
      if ch = 'V' then B[i].orient:=1
                  else B[i].orient:=2;
	  readln(FIn,B[i].c[1], B[i].c[2], B[i].len);
    end;
  CreateTable;
end;

procedure Move(i,j:longint);
var
  k,l:integer;
begin
  if j>0 then k:=1
         else k:=-1;
  Put(i,0);
  for l:=1 to abs(j) do
    begin
      B[i].C[B[i].orient]:=B[i].C[B[i].orient]+k;
	  if not CanPut(i) then Error('Test not passed');
    end;
  Put(i,1);
end;

begin
  Assign(FIn, paramstr(1));
  Reset(FIn);
  Assign(FOut, paramstr(2));
  Reset(FOut);
  Assign(UserOut, paramstr(3));
  Reset(UserOut);
  InputData;
  {$I-}
  read(UserOut, uout);
  {$I+}
  if IOResult<>0 then Error('Test not passed');
  read(FOut, out);
  if out<uout then Error('Test not passed');
  for i:=1 to out-1 do
	begin
	  {$I-}
	  Read(UserOut,j,k);
	  {$I+}
	  if IOResult<>0 then Error('Test not passed');
	  if (k=0) or (j>n) or (j<1) then Error('Test not passed');
	  Move(j,k);
	end;
  for i:=B[1].c[2]+2 to 6 do
	if Table[3,i]=1 then Error('Test not passed');
  if Out<>UOut then Error('Test passed, better than author!!!');
  Error('Test passed');
end.